var AutoForneController = function(ScreenService, MessageService, AutoForneService, templateManager, General, Utilities, maskEngine, ZhUtil, MessageManager, $http, metaDataFactory) {
	/* global $ */ /* global getLocalVar */ /* global Configuration */ /* global Constants */
	var self = this;
	
	this.load = function() {
		window.templateUrls.push({
	        package: "label",
            baseUrl: "./assets/templates/html/label.html"
	    });
    };
	      //
    this.removeContainer = function() {
		let name = "product#AutorizacaoFornecimento";
		if(templateManager.containers[name]) {
			delete templateManager.containers[name];
		}
	};
    
	this.buildRowsToUpdate = function(checkedRows, nrLabel) {
		let arrayNrAutoForn = [];
			
		for (let checkedRow of checkedRows) {
			arrayNrAutoForn.push(checkedRow.NRAUTOFORN);
		}
		
		return { 
			'P_NRAUTOFORN': arrayNrAutoForn.join('_'),
			'P_NRETIQUETA': nrLabel,
			'P_CDOPERADOR': getLocalVar('CDOPERADOR')
		};
	};
    
	this.openPopUpLabels = function(widgetName) {
		const row = {
			"P_CDOPERADOR" : getLocalVar('CDOPERADOR'),
			"P_CDFORNECED" : getLocalVar('CDFORNECED'),
			"P_NRORG"	   : getLocalVar('NRORG')
		};
		
		General.callRestEngine('product#/getLabels', 'Row', row).then(function(success) {
			const widget = templateManager.container.getWidget(widgetName);
			widget.labels = success.dataset.etiquetas;
			ScreenService.openPopup(widget);
		});
	};
	
	this.capitalizeFirstLetter = function(string) {
	    return string.charAt(0).toUpperCase() + string.slice(1);
	};
	
	this.insertLabel = function() {
		const widgetLabels = templateManager.container.getWidget('formLabels');
		
		if (widgetLabels.isValid()) {
			if (widgetLabels.labels.length < 10) {
				const fieldNovaEtiqueta = widgetLabels.getField('DSETIQUETA');
				const labelName = self.capitalizeFirstLetter(fieldNovaEtiqueta.value());
				
				const row = {
					'P_DSETIQUETA' : labelName,
					"P_CDOPERADOR" : getLocalVar('CDOPERADOR'),
					"P_CDFORNECED" : getLocalVar('CDFORNECED'),
					"P_NRORG"	   : getLocalVar('NRORG')
				};
				
				General.callRestEngine('product#/saveLabel', 'Row', row).then(function(success) {
					fieldNovaEtiqueta.clearValue();
					ScreenService.closePopup(widgetLabels);
					self.openPopUpLabels('formLabels');
				}, function(err) {
					MessageService.showMessageByCode("labelExists", null, Constants.alertMessage);
				});
			} else {
				MessageService.showMessageByCode("labelLimit", null, Constants.alertMessage);
			}
		}
	};
	
	this.unbindLabel = function() {
		const widgetAutoForne = templateManager.container.getWidget('autoForne');
		const checkedRows = widgetAutoForne.dataSource.getCheckedRows();
	
		if (checkedRows.length > 0) {
			const row = self.buildRowsToUpdate(checkedRows, null);
			
			General.callRestEngine('product#/unbindLabels', 'Row', row).then(function(success) {
				widgetAutoForne.reload();
			});
		} else {
			MessageService.showMessageByCode("selectAFUnlinkLabel", null, Constants.alertMessage);
		}
	};
	
	function setFieldData(widget) {
		widget.getField('IDTCLASSENVAFOR').dataSource.data = [
            {
                "code": "N",
                "name": ScreenService.i18n("Normal")
            },
            {
                "code": "E",
                "name": ScreenService.i18n("Extra")
            },
            {
                "code": "A",
                "name": ScreenService.i18n("Antecipação")
            },
            {
                "code": "C",
                "name": ScreenService.i18n("Complemento")
            },
            {
                "code": "I",
                "name": ScreenService.i18n("Inauguração")
            },
            {
                "code": "P",
                "name": ScreenService.i18n("Planilha de Alteração")
            }
        ];
        
        widget.getField('STATUS').dataSource.data = [
            {
                "code": "N",
                "name": ScreenService.i18n("Disponível")
            },
            {
                "code": "S",
                "name": ScreenService.i18n("Lido")
            }
        ];
        
        widget.getField('IDSITUATENDIMENTOAF').dataSource.data = [
            {
                "code": "C",
                "name": ScreenService.i18n("Confirmada")
            },
            {
                "code": "P",
                "name": ScreenService.i18n("Confirmada Parcialmente")
            },
            {
                "code": "R",
                "name": ScreenService.i18n("Recusada")
            },
            {
                "code": "N",
                "name": ScreenService.i18n("Pendente")
            }
		];
		
		widget.getField('AFCANCELADA').dataSource.data = [
            {
                "code": "N",
                "name": ScreenService.i18n("Não")
            },
            {
                "code": "S",
                "name": ScreenService.i18n("Sim")
            }
        ];
	}
	
	this.abrirFiltro = function() {
		const widget = templateManager.container.getWidget('autoForne');
		
		setFieldData(widget);
		
		const filterRow = {
            STATUS: ["N"],
            IDSITUATENDIMENTOAF : ["N"]
        };
		
		Utilities.startFilter(widget, filterRow);	
	};
	
	this.setReverseVisionButtonVisibility = function(widget) {
		let visibility = false;
		
		if (widget.dataSource.data.length > 0) {
			visibility = widget.dataSource.data[0].IDUTLCONFIMATENDAF == "S" ? true : false;
		}
		
		widget.getAction('reverseVision').isVisible = visibility;
	};
	
	this.defineStripe = function(filterRow) {
		const widgetStripe = templateManager.container.getWidget('STRIPE');
		const widgetGrid = templateManager.container.getWidget('autoForne');
		const widgetProd = templateManager.container.getWidget('infoProdutos');
		let cdForneced = getLocalVar('CDFORNECED');
		
		this.setReverseVisionButtonVisibility(widgetGrid);

		AutoForneService.retornaParamAtendEmailResponsavel(cdForneced).then(function(response) {
			let data = response.dataset.data;
			setLocalVar('DSEMAILNOTIFATENDAF', data.DSEMAILNOTIFATENDAF);
            setLocalVar('IDUTLCONFIMATENDAF', data.IDUTLCONFIMATENDAF);
			if(data.IDUTLCONFIMATENDAF === 'N'){
    			widgetGrid.getAction('CONFIRMAR').isVisible = false;
    			widgetGrid.getAction('RECUSAR').isVisible = false;
    			widgetGrid.getField('STATUSAF').isVisible = false;
    			widgetProd.showCheckbox = false;
    		} else {
    			widgetGrid.getAction('CONFIRMAR').isVisible = true;
    			widgetGrid.getAction('RECUSAR').isVisible = true;
    			widgetGrid.getField('STATUSAF').isVisible = true;
    			widgetProd.showCheckbox = true;
    		}
			
			let rowStripe = [];
			
			const tipos = {
		        "N": ScreenService.i18n("Normal"),
		        "E": ScreenService.i18n("Extra"),
		        "A": ScreenService.i18n("Antecipação"),
		        "C": ScreenService.i18n("Complemento"),
		        "I": ScreenService.i18n("Inauguração"),
		        "P": ScreenService.i18n("Planilha de Alteração")
			};
			
			const status = {
		        "N": ScreenService.i18n("Disponível"),
		        "S": ScreenService.i18n("Lido")
			};
			
			const atendimento = {
		        "C": ScreenService.i18n("Confirmada"),
		        "P": ScreenService.i18n("Confirmada Parcialmente"),
		        "R": ScreenService.i18n("Recusada"),
		        "N": ScreenService.i18n("Pendente")
			};
			
			rowStripe.DTENTREGAFFORN = filterRow.DTPROGENTAF.start ? filterRow.DTPROGENTAF.start + ' - ' + filterRow.DTPROGENTAF.end : ScreenService.i18n("Todas");
			rowStripe.IDTCLASSENVAFOR = filterRow.IDTCLASSENVAFOR && filterRow.IDTCLASSENVAFOR.length ? agrupaLista(filterRow.IDTCLASSENVAFOR, tipos) : ScreenService.i18n("Todos");
			rowStripe.STATUS = filterRow.STATUS && filterRow.STATUS.length ? agrupaLista(filterRow.STATUS, status) : ScreenService.i18n("Todos");
			rowStripe.IDSITUATENDIMENTOAF = filterRow.IDSITUATENDIMENTOAF && filterRow.IDSITUATENDIMENTOAF.length ? agrupaLista(filterRow.IDSITUATENDIMENTOAF, atendimento) : ScreenService.i18n("Todos");
			
			rowStripe.LEGENDARED = ScreenService.i18n("     Cancelada");
			rowStripe.LEGENDAPURPLE = ScreenService.i18n("     Planilha de Alteração");
			rowStripe.LEGENDABLUE = ScreenService.i18n("     Lido");
			rowStripe.LEGENDAGREEN = ScreenService.i18n("     Disponível");
			
			widgetStripe.currentRow = rowStripe;
		});
	};
	
	this.setFilterInfo = function(widgetStripe, widget) {
		let stripeRow = widgetStripe.currentRow;
		let row = widget.appliedFilter.FILTER_ROW;
		let antecipada;
		let filterInfo = [];
		filterInfo = [
			{"label": ScreenService.i18n("Data de Entrega"), "value": stripeRow.DTENTREGAFFORN},
			{"label": ScreenService.i18n("Status"), "value": stripeRow.STATUS},
			{"label": ScreenService.i18n("Confirmação de Atendimento"), "value": stripeRow.IDSITUATENDIMENTOAF}
		];
		widget._filterInfo = filterInfo;
	};
	
	function agrupaLista(lista, indices) {
		let valor;
		
		valor = lista.map((item) => {
			return indices[item];
		});
		
		return valor.join(', ');
	}
	
	this.setWidgetProperty = function(widget, property, value) {
		templateManager.container.getWidget(widget)[property] = value;
	};
	
	function getMessageDSPayment(currentRowDadosAF) {
    	let message = "";
                       
    	if (currentRowDadosAF.IDTPFORPGTAF == 'S') {
    		message = ScreenService.i18n("Sem forma de pagamento."); 
    	} else if (currentRowDadosAF.IDTPFORPGTAF == 'F') {
    		let variables = { NRDIAPGFIXAF: currentRowDadosAF.NRDIAPGFIXAF, NRPARCPGTOAF: currentRowDadosAF.NRPARCPGTOAF};
    		MessageService.getMessageByCode("paymentFixed").then( (msg) => {
            	message = ScreenService.i18n(msg, variables);
            	message += currentRowDadosAF.NRPARCPGTOAF > 1 ? ScreenService.i18n(" parcelas.") : ScreenService.i18n(" parcela");
            
            	if (currentRowDadosAF.IDUTDIAPGTAF == 'E') {
					message += ScreenService.i18n(" Primeira parcela no próximo mês.");
				}
            });
    	}
    	
    	return message;
    }

	this.fecharSwipe = function(gridWidget) {
		ScreenService.closeSwipe().then(function() {
			gridWidget.activate();
		});
	};

	this.openSwipeProduto = function() {
		const rowDadosAF = templateManager.container.getWidget('autoForne').currentRow;
		const tabbedProdutos = templateManager.container.getWidget('produtoAF');
		const dadosUnidade = templateManager.container.getWidget('dadosUnidade');
		
		const dataSourceFilter = [
			{ "name": "P_CDFILDEST", "operator": "=", "value": rowDadosAF.CDFILDEST },
			{ "name": "P_CDFILLANC", "operator": "=", "value": rowDadosAF.CDFILLANC },
			{ "name": "P_NRAUTOFORN", "operator": "=", "value": rowDadosAF.NRAUTOFORN }
		];
		
		dadosUnidade.dataSourceFilter = [
			{ "name": "P_CDFILIAL", "operator": "=", "value": rowDadosAF.CDFILDEST }
		];
		
		dadosUnidade.reload().then(function(callback){
			dadosUnidade.currentRow = callback.dataset.dadosUnidade[0];
		});
		
		controlaVisibilidadePlanilhaAlteracao(dataSourceFilter, rowDadosAF);
		
		controlaVisibilidadeFormaPagamento(dataSourceFilter, rowDadosAF);
		
		ScreenService.openSwipe(tabbedProdutos);
    };
    
    function controlaVisibilidadePlanilhaAlteracao(dataSourceFilter, rowDadosAF) {
    	const widgetProdutos = templateManager.container.getWidget('infoProdutos');
    	
    	if (rowDadosAF.IDTCLASSENVAFOR == 'P') {
			
			widgetProdutos.getField("DTPROGENTAFANT").isVisible = true;
			widgetProdutos.getField("DTPROGENTAFDEP").isVisible = true;
			widgetProdutos.getField("QTPROGENTANT").isVisible = true;
			widgetProdutos.getField("QTPROGENTDEP").isVisible = true;
			widgetProdutos.getField("DSJUSTITMAF").isVisible = true;
			
			widgetProdutos.getField("DTPROGENTAF").isVisible = false;
			widgetProdutos.getField("QTPROGENTAF").isVisible = false;
			widgetProdutos.getField("QTREST").isVisible = false;
			widgetProdutos.getField("VRDESCITMAF").isVisible = false;
			
		} else {
			
			widgetProdutos.getField("DTPROGENTAFANT").isVisible = false;
			widgetProdutos.getField("DTPROGENTAFDEP").isVisible = false;
			widgetProdutos.getField("QTPROGENTANT").isVisible = false;
			widgetProdutos.getField("QTPROGENTDEP").isVisible = false;
			widgetProdutos.getField("DSJUSTITMAF").isVisible = false;
			
			widgetProdutos.getField("DTPROGENTAF").isVisible = true;
			widgetProdutos.getField("QTPROGENTAF").isVisible = true;
			widgetProdutos.getField("QTREST").isVisible = true;
			widgetProdutos.getField("VRDESCITMAF").isVisible = true;
			
		}
		if(rowDadosAF.IDSITUATENDIMENTOAF === 'N' && getLocalVar('IDUTLCONFIMATENDAF') === 'S'){
			widgetProdutos.getAction("RECUSAR").isVisible = true;
			widgetProdutos.getField("STATUSAFPROD").isVisible = true;
			widgetProdutos.showCheckbox = true;
		}else{
			if(rowDadosAF.IDSITUATENDIMENTOAF != 'N' && getLocalVar('IDUTLCONFIMATENDAF') === 'S'){
				widgetProdutos.getField("STATUSAFPROD").isVisible = true;
			}else{
				widgetProdutos.getField("STATUSAFPROD").isVisible = false;
			}
			widgetProdutos.getAction("RECUSAR").isVisible = false;
			widgetProdutos.showCheckbox = false;
		}
		
		
		widgetProdutos.dataSourceFilter = dataSourceFilter;
		widgetProdutos.reload();
    }
    
    function controlaVisibilidadeFormaPagamento(dataSourceFilter, rowDadosAF) {
		const widgetInfoPagGrid = templateManager.container.getWidget("infoPagamentoGrid");
		const widgetInfoPag = templateManager.container.getWidget('infoPagamento');
    	
    	if (rowDadosAF.IDTPFORPGTAF == 'V') {
			self.setWidgetProperty('infoPagamento', 'isVisible', false);
			self.setWidgetProperty('infoPagamentoGrid', 'isVisible', true);
			
			widgetInfoPagGrid.dataSourceFilter = dataSourceFilter;
			widgetInfoPagGrid.reload();
		} else {
			self.setWidgetProperty('infoPagamento', 'isVisible', true);
			self.setWidgetProperty('infoPagamentoGrid', 'isVisible', false);
			
			const dsPgto = getMessageDSPayment(rowDadosAF);
			
			widgetInfoPag.currentRow = {
				"DSPAGAMENTO": dsPgto,
			};
		}
    }
    
	function montaLista(afs) {
		const row = {
            "CDFILDEST":	   '',
            "NRAUTOFORN":	   '',
            "NRSEQAPURAF":	   '',
        	"TIPO":            '0',
            "CDFORNECED":	   getLocalVar('CDFORNECED'),
            "CDFILLANC":	   'T',
            "CDFILLANCPADAF":  '',
            "NRSEQENVIOAFORN": 'T',
            "NRLOGPLANITEMAF": afs[0].NRLOGPLANITEMAF,
            "CODOPERADOR":	   getLocalVar('CDOPERADOR'),
            "DSLOGINECO":      getLocalVar('DSLOGINECO'),
            "NMFANTFORN":      getLocalVar('NMFANTFORN'),
            "NRORG":		   getLocalVar('NRORG'),
            "IDEXIBEOBSFIL":   'S',
            "IMPRIMEOBSPROD":  'S',
            "PROXMES":         'N',
            "AFS_SELECIONADAS": afs
        };
        
        for (let af of afs) {
        	
        	row.CDFILDEST += row.CDFILDEST.indexOf(af.CDFILDEST) == -1 ? row.CDFILDEST ? '_' + af.CDFILDEST : af.CDFILDEST : '';
        	row.NRAUTOFORN += row.NRAUTOFORN.indexOf(af.NRAUTOFORN) == -1 ? row.NRAUTOFORN ? '_' + af.NRAUTOFORN : af.NRAUTOFORN : '';
        	row.CDFILLANCPADAF += row.CDFILLANC.indexOf(af.CDFILLANC) == -1 ? row.CDFILLANC ? '_' + af.CDFILLANC : af.CDFILLANC : '';
        	
    		if (af.NRSEQAPURAF && row.NRSEQAPURAF != 'T') {
                if (row.NRSEQAPURAF.indexOf(af.NRSEQAPURAF) == -1) {
                	if (row.NRSEQAPURAF) {
                        row.NRSEQAPURAF +=        '_' + af.NRSEQAPURAF;
                    } else {
                        row.NRSEQAPURAF = af.NRSEQAPURAF;
                    }
                }
            } else {
               row.NRSEQAPURAF = 'T';
        	}
        }
        
        return row;
	}
	
	this.openPopupReport = function(widgetChecked, widgetReport, defaultObject) {
		const widgetRelatorio = templateManager.container.getWidget('formRelatorio');
		const widgetAf = templateManager.container.getWidget('autoForne');
		const afsSelecionadas = widgetAf.dataSource.getCheckedRows();
		if (afsSelecionadas.length > 0) {
			ScreenService.openPopup(widgetRelatorio);
		} else {
			MessageService.showMessageByCode("selectAFPrint", null, Constants.alertMessage);
		}
	};
	
	this.checkIsGrReport = function() {
		General.callRestEngine("product#/verificaIdSisDos", "DataSet", []).then(function(callback) {
			const widgetReport = templateManager.container.getWidget("formRelatorio");
			let idSisDos = callback.dataset.resp.IDSISDOS;
			
			if (idSisDos != 3) {
				const field = widgetReport.getField('report_name');
				
				field.dataSource.data.shift();
				field.defaultValue = field.dataSource.data[0].valor;
			}
		});
	};

    this.exportaRelatorio = function() {
    	const widgetRelatorio = templateManager.container.getWidget('formRelatorio');
    	let   reportName = widgetRelatorio.currentRow.report_name;
		const widgetAf = templateManager.container.getWidget('autoForne');
		const rowsAf = widgetAf.dataSource.getCheckedRows();
		
		General.callRestEngine("product#/verificaIdSisDos", "DataSet", []).then(function(callback) {
			let idSisDos = callback.dataset.resp.IDSISDOS;
			if ((idSisDos == 3) && (reportName == 'padraoEnvioAF')) {
				reportName = 'padraoEnvioAFGR';
			}
	    	if (widgetRelatorio.isValid() && verificaPlanilhaAlteracao(rowsAf, reportName)) {
				let newRow = montaLista(rowsAf);
				newRow.IDSISDOS = idSisDos;
				if(reportName == 'LIB04502'){
					newRow.CDPICTPROD = getLocalVar("CDPICTPROD").replace(/[^(/\.|\ )]/g, "@");
				}
				General.openReport('/lib04500', reportName, newRow).then(() => {
					ScreenService.closePopup(true);
					widgetAf.reload();
					widgetAf.activate();
				});
			}
		});
	};
	
	function verificaPlanilhaAlteracao(rowsAf, codigoRelatorio) {
		if (codigoRelatorio == 'LIB04502' && rowsAf.length > 1) {
			MessageService.showMessageByCode("selectOnlyOneAFReport", null, Constants.alertMessage);
			
			return false;				
		}
			
		return true;
	}
    
    this.fechaSwipe = function(widgetActivate){
        ScreenService.closeSwipe();
        widgetActivate.activate();
        widgetActivate.redraw();
    };
	
    this.openPopupExportacaoXml = function() {
    	const popupExportacaoXml = templateManager.container.getWidget('popupExportacaoXml');
    	const afsSelecionadas = templateManager.container.getWidget('autoForne').dataSource.getCheckedRows();
    	
    	if(afsSelecionadas.length) {
    		ScreenService.openPopup(popupExportacaoXml);	
    	} else {
    		MessageService.showMessageByCode("selectAFExport", null, Constants.alertMessage);
		}
    };
	
	this.exportarXml = function() {
		const widgetAf = templateManager.container.getWidget('autoForne');
		const afsSelecionadas = widgetAf.dataSource.getCheckedRows();
		const rowPopupExportacaoXml = templateManager.container.getWidget('popupExportacaoXml').currentRow;
		
		const paramExportarXml = montaParamExportarXml(afsSelecionadas, rowPopupExportacaoXml);
		
		AutoForneService.exportarXml(paramExportarXml).then(function(response) {
			
        	const textoXml = response.messages[0].message;
			const listaAf = Object.keys(textoXml);
			
			for (let af of listaAf) {
        		Utilities.downloadArquivoNavegador(textoXml[af], af + '.xml');
			}
			
        	ScreenService.closePopup(true);
        	widgetAf.reload();
        	widgetAf.activate();
			
        }).catch((error) => {
			MessageService.showMessageByCode("exportError", null, Constants.errorMessage);
        });
	};
	
	function montaParamExportarXml(linhasSelecionadas, row) {
		let params = {
			"DSLOGINECO": getLocalVar('DSLOGINECO'),
			"CDFORNECED": getLocalVar('CDFORNECED'),
			"NMFANTFORN": getLocalVar('NMFANTFORN'),
			"QUEBRA_XML_AF": row.QUEBRA_XML_AF == '1' ? true : false,
			"REPORT_NAME": row.REPORT_NAME,
			"AFS_SELECIONADAS": linhasSelecionadas
		};
		
		return params;
	}
	
	//RETIRAR METODO DO EVENTO FilterBeforeApply DA WIDGET autoForne APOS LIBERAÇÃO DA ISSUE 236634
	this.retiraFiltroFloatButton = function(filterRow) {
		const widgetAF = templateManager.container.getWidget('autoForne');
		widgetAF.getField('STATUS').isVisible = true;
		
		if (filterRow) {
			delete filterRow.SEARCHLIST__ALL_MAP;
		}
	};
	
	this.filterPendingRows = function(selectedRows) {
		return selectedRows.filter(function(row) {
		    if (row.IDSITUATENDIMENTOAF != 'P' && row.IDSITUATENDIMENTOAF != 'C' && row.IDSITUATENDIMENTOAF != 'R') {
		        return row;
		    }
		});
	};
	
	this.getPendingAFs = function(widget) {
		const selectedRows = widget.getCheckedRows();
		return self.filterPendingRows(selectedRows);
	};
	
	this.confirmarAF = function(widget){
		const pendingAFs = self.getPendingAFs(widget);
		
		if (pendingAFs.length > 0) {
			MessageService.confirmMessageByCode("confirmAF").then(() => {
			
				MessageManager.registerProcesses(["ConfirmAF", "SendMail"]);
				
				AutoForneService.confirmarAF(pendingAFs).then(function(response) {
					const messages = response.dataset.MESSAGES;
					
					if (messages.SENDMAIL.ERROR != "") {
						MessageManager.setParameter("ERROR", messages.SENDMAIL.ERROR);
					}
					
					MessageManager.notify("ConfirmAF", messages.UPDATEAF.MESSAGE, messages.UPDATEAF.STATUS);
					MessageManager.notify("SendMail", messages.SENDMAIL.MESSAGE, messages.SENDMAIL.STATUS);
					
					widget.reload();
				}).catch(MessageManager.showErrorMessage);
			});
		} else {
			MessageService.showMessageByCode("invalidAFsSelected");
		}
	};
	
	this.confirmarRecusa = function(widget) {
		if(widget.isValid()) {
			let selectedRows = [];
			let currentRow = widget.currentRow;
			if(widget.gridAF) {
				MessageService.confirmMessageByCode("refuseAF").then(() => {
					const pendingAFs = self.getPendingAFs(widget.getParent());
					
					if (pendingAFs.length > 0) {
						const authPopupWidget = widget.container.getWidget('authPopup');
						authPopupWidget.currentRow = {};
						authPopupWidget.currentRow.SELECTEDROWS = pendingAFs;
						authPopupWidget.currentRow.TXJUSTIFICATIVA = widget.currentRow.TXJUSTIFICATIVA;
						ScreenService.openPopup(authPopupWidget);
					} else {
						MessageService.showMessageByCode("invalidAFsSelected");
						ScreenService.closePopup();
					}
				});
			} else {
				MessageService.confirmMessageByCode("refuseProductsAF").then(() => {
					const widgetProdutos = widget.container.getWidget('infoProdutos');
					selectedRows = widgetProdutos.getCheckedRows();
					const rowDadosAF = templateManager.container.getWidget('autoForne').currentRow;
					AutoForneService.confirmarRecusa(selectedRows, rowDadosAF, currentRow).then(function(response) {
						ScreenService.closePopup();
						widgetProdutos.reload();
						MessageService.notificationMessageByCode("successOnSave", null, Constants.successNotification);
					});
				});
			}
		}
	};
	
	this.autenticaOperador = function(widget) {
		if (widget.isValid()) {
			widget.currentRow.OPERADORLOGADO = getLocalVar('CDOPERADOR');
			widget.currentRow.EMAILLOGADO = getLocalVar('EMAIL');
			widget.currentRow.NMFANTFORN = getLocalVar('NMFANTFORN');
			widget.currentRow.DSEMAILNOTIFATENDAF = getLocalVar('DSEMAILNOTIFATENDAF');
			var request = {
				route: "product#/autenticaOperador",
				type: "Row",
				params: widget.currentRow
			};
			
			MessageManager.registerProcesses(["AuthOperator", "RefuseAF", "SendMail"]);
			
			General.callRestEngine(request.route, request.type, request.params).then(function(callback) {
				const messages = callback.dataset.MESSAGES;
				
				if (messages.SENDMAIL.ERROR != "") {
					MessageManager.setParameter("ERROR", messages.SENDMAIL.ERROR);
				}
				
				MessageManager.notify("AuthOperator", messages.AUTHOPERATOR.MESSAGE, messages.AUTHOPERATOR.STATUS);
				MessageManager.notify("RefuseAF", messages.REFUSEAF.MESSAGE, messages.REFUSEAF.STATUS);
				MessageManager.notify("SendMail", messages.SENDMAIL.MESSAGE, messages.SENDMAIL.STATUS);
				
				ScreenService.closePopup(true);
				let gridWidget = widget.container.getWidget('autoForne');
				gridWidget.reload();
				widget.container.getWidget('infoProdutos').reload();
				gridWidget.activate();
				MessageService.notificationMessageByCode("successOnSave", null, Constants.successNotification);
			}).catch(MessageManager.showErrorMessage);
		}
	};
	
	this.checkOpenJustificativa = function(widgetJustificativa, gridAF){
		if (gridAF) {
			const widget = templateManager.container.getWidget("autoForne");
			const pendingAFs = self.getPendingAFs(widget);
			
			if (pendingAFs.length > 0) {
				self.openJustificativa(widgetJustificativa, gridAF);
			} else {
				MessageService.showMessageByCode("invalidAFsSelected");
			}
		} else {
			self.openJustificativa(widgetJustificativa, gridAF);
		}
	};
	
	this.openJustificativa = function(widgetJustificativa, gridAF) {
		ScreenService.openPopup(widgetJustificativa); 
		widgetJustificativa.gridAF = gridAF; 
		widgetJustificativa.currentRow = {};
	};
	
	/* FUNÇÕES REFERENTES A TELA DE VISÃO INVERTIDA */
	
	this.reverseVision = function(widget){
    	let afs = widget.dataSource.data;
    	let nrAfs = [];
    	let cdFiliLancAfs = [];
    	let cdFilDestAfs = [];
		for (let af of afs) {
    		nrAfs.push(af.NRAUTOFORN);
    		cdFiliLancAfs.push(af.CDFILLANC);
    		cdFilDestAfs.push(af.CDFILDEST);
		}
        ScreenService.openWindow("product#AutorizacaoFornecimentoPorProduto").then(function() {
        	const prodInv = templateManager.container.getWidget('infoProdutos');
        	prodInv.externalParams = {
        		CDFILDEST : removeDuplicates(cdFilDestAfs),
        		CDFILLANC : removeDuplicates(cdFiliLancAfs),
        		NRAUTOFORN : removeDuplicates(nrAfs)
        	};
        });
    };
    
    function removeDuplicates(array) {
		return array.splice(0, array.length, ...(new Set(array)));
	}
    
    this.hideCheckboxHeader = function() {
    	$('#grid-1187572093904743709239 .th.grid-checkbox-column.fixed').css('pointer-events', 'none');
    	
    	$('.container.zh-grid-container').on('click', '.td.grid-group-header', function () {
		    if ($('.td.grid-group-header.opened').length == 2 && $(this).attr('class') == 'td grid-group-header opened') {
		        $('.td.grid-group-header.opened').not(this).trigger('click');
		    }
		});
    };
    
    this.carregaProdutosVisaoInvertida = function() {
    	const widget = templateManager.container.getWidget('infoProdutos');
    	try {
	    	widget.dataSourceFilter = [
				{ "name": "P_CDFILDEST", "operator": "=", "value": widget.externalParams.CDFILDEST.join('_') },
				{ "name": "P_CDFILLANC", "operator": "=", "value" : widget.externalParams.CDFILLANC.join('_') },
				{ "name": "P_NRAUTOFORN", "operator": "=", "value": widget.externalParams.NRAUTOFORN.join('_') }
			];
			widget.reload();
			widget.activate();
    	} catch(error) {
    		ScreenService.openWindow('product#AutorizacaoFornecimento');
    	}
	};
	
	this.verificaProdutoMarcado = function(row) {
		let widget = templateManager.container.getWidget('infoProdutos');
		let groupHeaders = row.__groupHeaders;
		let productSelect = widget.productSelect; 
		
		if(groupHeaders && groupHeaders.length) {
			let grouped = row.__groupHeaders[0].__groupValue;
			if(!widget.getCheckedRows().length) {
				productSelect = null;
			} else {
				productSelect = widget.getLastSelectedRow().__groupHeaders[0].__groupValue;
			}
			widget.container.getWidget('STRIPEWID').currentRow.PRODUTO = productSelect;
			return !(productSelect == grouped || productSelect == null);
		} else {
			return false;
		}
	};		
	
	this.verificaSituAf = function() {
		const widget = templateManager.container.getWidget('infoProdutos'); 
		let rowsSelected = widget.getCheckedRows();
		let afPendente = false;
		
		for (let row of rowsSelected) {
    		if(!row.IDSITUATENDIMENTOITM) {
    			afPendente = true;
    		}
		}
		
		if(afPendente) {
			widget.getAction('CONFIRMAR').isVisible = true;
			widget.getAction('RECUSAR').isVisible = true;
		} else {
			widget.getAction('CONFIRMAR').isVisible = false;
			widget.getAction('RECUSAR').isVisible = false;
		}
		this.setStripe(widget);
	};

	this.setStripe = function(widget) {
		let mascara = {
	                "type": "float",
	                "params": {
	                    "symbol": "",
	                    "precision": 3
	                }
	            };
	            
	    let rowsSelected = widget.getCheckedRows();
		let qtdeProd = Util.applyMask(this.calculaQtdeMarcada(rowsSelected), mascara, maskEngine, ZhUtil);
		widget.container.getWidget('STRIPEWID').currentRow.QTDE = qtdeProd;
		widget.container.getWidget('STRIPEWID').reload();
	};
	
	this.calculaQtdeMarcada = function(rowsSelected) {
		let qtdeArray = [];
		for (let row of rowsSelected) {
    		qtdeArray.push(parseFloat(row.QTPROGENTAF));
		}
		
		if (qtdeArray.length == 0 || qtdeArray.length == 1) {
			const gridScroll = $('.grid-vertical-scroll-control');
			const header = $(".td.grid-group-header.opened");
			
			if (gridScroll.length && header.length) {
				const offsetTop = header.offset().top;
				const scrollTopValue = gridScroll.scrollTop();
				
				$('.grid-vertical-scroll-control').animate({
                    scrollTop: (scrollTopValue + (offsetTop - 121))
                }, 100);
			}
		}
		
		if(qtdeArray.length) {
			return qtdeArray.reduce(function(accumulator, currentValue) {
				return accumulator + currentValue;
			});
		} else {
			return null;
		}
	};
	
	this.voltarTelaAf = function() {
		ScreenService.openWindow('product#AutorizacaoFornecimento').then(function() {
			const widget = templateManager.container.getWidget('autoForne');
			const widgetStripe = templateManager.container.getWidget('STRIPE');
			MessageService.showMessageByCode("confirmItemsChange", null, Constants.alertMessage).then(() => {
				widget.activate();
				self.setFilterInfo(widgetStripe, widget);
			});
		});
	};
	
	this.confirmarRecusaItem = function(widget){
		if(widget.isValid()) {
			let selectedRows = [];
			let currentRow = widget.currentRow;
			let widStripe = templateManager.container.getWidget('STRIPEWID'); 
			MessageService.confirmMessageByCode("refuseItems").then(() => {
				const widgetProdutos = widget.container.getWidget('infoProdutos');
				selectedRows = widgetProdutos.getCheckedRows();
				AutoForneService.confirmarRecusaItens(selectedRows, currentRow).then(function(response) {
					ScreenService.closePopup();
					widgetProdutos.reload();
					widStripe.currentRow = {};
				    MessageService.notificationMessageByCode("successOnSave", null, Constants.successNotification);
				});
			});
		}
	};
	
	this.confirmarItensAF = function(widget){
		if(widget.isValid()) {
			let widStripe = templateManager.container.getWidget('STRIPEWID'); 
			let selectedRows = [];
			MessageService.confirmMessageByCode("confirmItems").then(() => {
				const widgetProdutos = widget.container.getWidget('infoProdutos');
				selectedRows = widgetProdutos.getCheckedRows();
				AutoForneService.confirmarItensAF(selectedRows).then(function(response) {
					ScreenService.closePopup();
					widgetProdutos.reload();
					widStripe.currentRow = {};
					MessageService.notificationMessageByCode("successOnSave", null, Constants.successNotification);
				});
			});
		}
	};
	
    this.saveCollectedData = function(){
    	let	dados = templateManager.container.getWidget('autoForne').dataSource.data;
    	if(dados.length > 0)
    	{
    		let cdfilial = [];
			let row = {
			  "COLLECTION_IDS" : null,
			  "OPERATION_ID"   : 'Utilização do portal E-commerce - Autorização de Fornecimento',
			};
			for(let row of dados){
				if(cdfilial.indexOf(row.CDFILDEST) == -1){
					cdfilial.push(row.CDFILDEST);
				}
			}
			row.CDFILIAL = cdfilial;
			General.callRestEngine("product#/saveCollectedDataAF", "Row", row);
    	}
    };
    
    this.getReportData = function(widget) {
    	let row = {
    		'0': "CMP039"
    	};
		General.callRestEngine('product#/getReportData', 'Row', row).then(function(response) {
			let reportDataBirt = response.dataset.dataReport.filter(function(report) {
				return report.strategy == "BIRT";
			});
			let reportField = widget.getField('report_name');
			reportField.dataSource.data = reportField.dataSource.data.concat(reportDataBirt);
			reportField.reload();
		});
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('AutoForneController', AutoForneController);
});